## Copyright 1992 OTC LIMITED
## Copyright 1995 DUMPLETON SOFTWARE CONSULTING PTY LIMITED

vpath %.c $(SRCDIR)
vpath %.c++ $(SRCDIR)
vpath %.cxx $(SRCDIR)
vpath %.cpp $(SRCDIR)
vpath %.cc $(SRCDIR)
vpath %.C $(SRCDIR)

vpath %.h $(SRCDIR)
vpath %.h++ $(SRCDIR)
vpath %.hxx $(SRCDIR)
vpath %.hpp $(SRCDIR)
vpath %.hh $(SRCDIR)
vpath %.H $(SRCDIR)

vpath %.mk $(SRCDIR)
vpath %.sed $(SRCDIR)

vpath %.1 $(SRCDIR)
vpath %.2 $(SRCDIR)
vpath %.3 $(SRCDIR)
vpath %.4 $(SRCDIR)
vpath %.5 $(SRCDIR)
vpath %.6 $(SRCDIR)
vpath %.7 $(SRCDIR)
vpath %.8 $(SRCDIR)

vpath mandesc $(SRCDIR)

## Standard targets.

.PHONY : install
.PHONY : install.setup
.PHONY : install.subdirs
.PHONY : install.target
.PHONY : install.always

install : install.setup
install : install.subdirs
install : install.target
install : install.always

install.setup :: makeit.setup

install.subdirs :: install.setup
ifneq "$(SUBDIRS)" ""
ifneq "$(filter navigate_all_variants,$(MAKEIT_OPTIONS))" ""
	@$(foreach var,$(VARIANTS),$(foreach dir,$(SUBDIRS), \
	 $(MAKE) -C $(dir) VARIANT=$(var) install || $(FAILACTION);))
else
	@$(foreach dir,$(SUBDIRS), \
	 $(MAKE) -C $(dir) install || $(FAILACTION);)
endif
endif

install.target :: install.setup

install.always :: install.setup

install.always :: install-lib.setup install-lib.always
install.always :: install-bin.setup install-bin.always
install.always :: install-inc.setup install-inc.always
install.always :: install-man.setup install-man.always
install.always :: install-aux.setup install-aux.always

.PHONY : install-lib
.PHONY : install-bin
.PHONY : install-inc
.PHONY : install-man
.PHONY : install-aux

install-lib : install-lib.setup
install-lib : install-lib.subdirs
install-lib : install-lib.target
install-lib : install-lib.always

install-bin : install-bin.setup
install-bin : install-bin.subdirs
install-bin : install-bin.target
install-bin : install-bin.always

install-inc : install-inc.setup
install-inc : install-inc.subdirs
install-inc : install-inc.target
install-inc : install-inc.always

install-man : install-man.setup
install-man : install-man.subdirs
install-man : install-man.target
install-man : install-man.always

install-aux : install-aux.setup
install-aux : install-aux.subdirs
install-aux : install-aux.target
install-aux : install-aux.always

.PHONY : install-lib.setup
.PHONY : install-bin.setup
.PHONY : install-inc.setup
.PHONY : install-man.setup
.PHONY : install-aux.setup

install-lib.setup :: install.setup
install-bin.setup :: install.setup
install-inc.setup :: install.setup
install-man.setup :: install.setup
install-aux.setup :: install.setup

.PHONY : install-lib.subdirs
.PHONY : install-bin.subdirs
.PHONY : install-inc.subdirs
.PHONY : install-man.subdirs
.PHONY : install-aux.subdirs

install-lib.subdirs :: install-lib.setup
ifneq "$(SUBDIRS)" ""
ifneq "$(filter navigate_all_variants,$(MAKEIT_OPTIONS))" ""
	@$(foreach var,$(VARIANTS),$(foreach dir,$(SUBDIRS), \
	 $(MAKE) -C $(dir) VARIANT=$(var) install-lib || $(FAILACTION);))
else
	@$(foreach dir,$(SUBDIRS), \
	 $(MAKE) -C $(dir) install-lib || $(FAILACTION);)
endif
endif

install-bin.subdirs :: install-bin.setup
ifneq "$(SUBDIRS)" ""
ifneq "$(filter navigate_all_variants,$(MAKEIT_OPTIONS))" ""
	@$(foreach var,$(VARIANTS),$(foreach dir,$(SUBDIRS), \
	 $(MAKE) -C $(dir) VARIANT=$(var) install-bin || $(FAILACTION);))
else
	@$(foreach dir,$(SUBDIRS), \
	 $(MAKE) -C $(dir) install-bin || $(FAILACTION);)
endif
endif

install-inc.subdirs :: install-inc.setup
ifneq "$(SUBDIRS)" ""
ifneq "$(filter navigate_all_variants,$(MAKEIT_OPTIONS))" ""
	@$(foreach var,$(VARIANTS),$(foreach dir,$(SUBDIRS), \
	 $(MAKE) -C $(dir) VARIANT=$(var) install-inc || $(FAILACTION);))
else
	@$(foreach dir,$(SUBDIRS), \
	 $(MAKE) -C $(dir) install-inc || $(FAILACTION);)
endif
endif

install-man.subdirs :: install-man.setup
ifneq "$(SUBDIRS)" ""
ifneq "$(filter navigate_all_variants,$(MAKEIT_OPTIONS))" ""
	@$(foreach var,$(VARIANTS),$(foreach dir,$(SUBDIRS), \
	 $(MAKE) -C $(dir) VARIANT=$(var) install-man || $(FAILACTION);))
else
	@$(foreach dir,$(SUBDIRS), \
	 $(MAKE) -C $(dir) install-man || $(FAILACTION);)
endif
endif

install-aux.subdirs :: install-aux.setup
ifneq "$(SUBDIRS)" ""
ifneq "$(filter navigate_all_variants,$(MAKEIT_OPTIONS))" ""
	@$(foreach var,$(VARIANTS),$(foreach dir,$(SUBDIRS), \
	 $(MAKE) -C $(dir) VARIANT=$(var) install-aux || $(FAILACTION);))
else
	@$(foreach dir,$(SUBDIRS), \
	 $(MAKE) -C $(dir) install-aux || $(FAILACTION);)
endif
endif

.PHONY : install-lib.target
.PHONY : install-bin.target
.PHONY : install-inc.target
.PHONY : install-man.target
.PHONY : install-aux.target

install-lib.target ::
install-bin.target ::
install-inc.target ::
install-man.target ::
install-aux.target ::

.PHONY : install-lib.always
.PHONY : install-bin.always
.PHONY : install-inc.always
.PHONY : install-man.always
.PHONY : install-aux.always

install-lib.always ::
install-bin.always ::
install-inc.always ::
install-man.always ::
install-aux.always ::

## Setup some definitions.

override INSTALL := $(strip $(INSTALL))

ifeq "$(INSTALL)" "cp"
override INSTALL := $(SCRIPTDIR)/install -c
endif

ifeq "$(INSTALL)" "cp"

INSTALL.LIB := $(INSTALL)
INSTALL.BIN := $(INSTALL)
INSTALL.INC := $(INSTALL)
INSTALL.MAN := $(INSTALL)
INSTALL.AUX := $(INSTALL)

else

ifeq "$(origin INSTALL.LIBFLAGS)" "undefined"
INSTALL.LIBFLAGS := -m 0664
endif
ifeq "$(origin INSTALL.BINFLAGS)" "undefined"
INSTALL.BINFLAGS := -m 0775
endif
ifeq "$(origin INSTALL.INCFLAGS)" "undefined"
INSTALL.INCFLAGS := -m 0444
endif
ifeq "$(origin INSTALL.MANFLAGS)" "undefined"
INSTALL.MANFLAGS := -m 0444
endif
ifeq "$(origin INSTALL.AUXFLAGS)" "undefined"
INSTALL.AUXFLAGS := -m 0444
endif

INSTALL.LIB := $(INSTALL) $(INSTALL.LIBFLAGS)
INSTALL.BIN := $(INSTALL) $(INSTALL.BINFLAGS)
INSTALL.INC := $(INSTALL) $(INSTALL.INCFLAGS)
INSTALL.MAN := $(INSTALL) $(INSTALL.MANFLAGS)
INSTALL.AUX := $(INSTALL) $(INSTALL.AUXFLAGS)

endif

## Installation for libraries.

ifneq "$(LIBDIR)" ""

_install_directories += $(LIBDIR)

ifneq "$(LIBRARY)" ""

install-lib.always :: lib.always

install-lib.always :: $(LIBDIR)/lib$(LIBRARY)$(LIBEXT)

$(LIBDIR)/lib$(LIBRARY)$(LIBEXT) : $(MK)/lib$(LIBEXT)
	$(INSTALL.LIB) $< $@
	$(RANLIB) -t $@

ifeq "$(_makeit_enable_shared_libraries)" "YES"

install-lib.always :: shlib.always
ifdef PICINSTALL
	$(PICINSTALL)
else
	@echo makeit:
	@echo makeit: Don't know how to install shared libraries on this host
	@echo makeit: architecture. Modify the host customisation file to
	@echo makeit: specify how to do this.
	@echo makeit:
	@echo makeit: Shared libraries have not been installed.
	@echo makeit:
endif

endif

endif

endif

## Installation for executables.

ifneq "$(BINDIR)" ""

_install_directories += $(BINDIR)

_install_BINARY_EXECUTABLES := $(notdir $(_makeit_MK_BINARIES))
_install_SCRIPT_EXECUTABLES := $(notdir $(_makeit_MK_SCRIPTS))

ifneq "$(origin EXECUTABLES)" "undefined"

_install_BINARY_EXECUTABLES := \
 $(filter $(EXECUTABLES),$(_install_BINARY_EXECUTABLES))

_install_SCRIPT_EXECUTABLES := \
 $(filter-out $(_install_BINARY_EXECUTABLES),$(EXECUTABLES))

endif

ifneq "$(_install_BINARY_EXECUTABLES)" ""

_install_BINDIR_BINARY_EXECUTABLES := \
 $(addprefix $(BINDIR)/,$(_install_BINARY_EXECUTABLES))

install-bin.always :: $(_install_BINDIR_BINARY_EXECUTABLES)

$(_install_BINDIR_BINARY_EXECUTABLES) : $(BINDIR)/% : $(MK)/%
	$(INSTALL.BIN) $< $@
ifneq "$(filter strip_binaries,$(INSTALL_OPTIONS))" ""
	strip $@
endif

endif

ifneq "$(_install_SCRIPT_EXECUTABLES)" ""

_install_BINDIR_SCRIPT_EXECUTABLES := \
 $(addprefix $(BINDIR)/,$(_install_SCRIPT_EXECUTABLES))

install-bin.always :: $(_install_BINDIR_SCRIPT_EXECUTABLES)

$(_install_BINDIR_SCRIPT_EXECUTABLES) : $(BINDIR)/% : $(MK)/%
	$(INSTALL.BIN) $< $@

endif

endif

## Installation for header files.

ifneq "$(INCDIR)" ""

_install_directories += $(INCDIR)

ifeq "$(origin INCLUDES)" "undefined"
_install_INCLUDES := \
 $(filter-out $(EXCLUDE),$(filter %.h %.hh %.hpp %.hxx %.H %.h++,$(SRCFILES)))
else
_install_INCLUDES := $(INCLUDES)
endif

ifneq "$(_install_INCLUDES)" ""

_install_INCDIR_INCLUDES := $(addprefix $(INCDIR)/,$(_install_INCLUDES))

install-inc.always :: $(_install_INCDIR_INCLUDES)

$(_install_INCDIR_INCLUDES) : $(INCDIR)/% : %
	$(INSTALL.INC) $< $@

endif

endif

## Installation for manual pages.

ifneq "$(MANDIR)" ""

_install_directories += $(MANDIR)

ifeq "$(origin MANDESC)" "undefined"
_install_MANDESC := $(filter mandesc,$(SRCFILES))
else
_install_MANDESC := $(MANDESC)
endif

ifneq "$(_install_MANDESC)" ""

install-man.always :: $(addprefix $(MANDIR)/,mandesc)

$(addprefix $(MANDIR)/,mandesc) : $(_install_MANDESC)
	$(INSTALL.MAN) $< $@

endif

ifneq "$(SECTION1)" ""

_install_directories += $(MANDIR)/man1

_install_MANDIR_SECTION1 := $(addprefix $(MANDIR)/man1/,$(SECTION1))

install-man.always :: $(_install_MANDIR_SECTION1)

$(_install_MANDIR_SECTION1) : $(MANDIR)/man1/% : %
	$(INSTALL.MAN) $< $@

endif

ifneq "$(SECTION2)" ""

_install_directories += $(MANDIR)/man2

_install_MANDIR_SECTION2 := $(addprefix $(MANDIR)/man2/,$(SECTION2))

install-man.always :: $(_install_MANDIR_SECTION2)

$(_install_MANDIR_SECTION2) : $(MANDIR)/man2/% : %
	$(INSTALL.MAN) $< $@

endif

ifneq "$(SECTION3)" ""

_install_directories += $(MANDIR)/man3

_install_MANDIR_SECTION3 := $(addprefix $(MANDIR)/man3/,$(SECTION3))

install-man.always :: $(_install_MANDIR_SECTION3)

$(_install_MANDIR_SECTION3) : $(MANDIR)/man3/% : %
	$(INSTALL.MAN) $< $@

endif

ifneq "$(SECTION4)" ""

_install_directories += $(MANDIR)/man4

_install_MANDIR_SECTION4 := $(addprefix $(MANDIR)/man4/,$(SECTION4))

install-man.always :: $(_install_MANDIR_SECTION4)

$(_install_MANDIR_SECTION4) : $(MANDIR)/man4/% : %
	$(INSTALL.MAN) $< $@

endif

ifneq "$(SECTION5)" ""

_install_directories += $(MANDIR)/man5

_install_MANDIR_SECTION5 := $(addprefix $(MANDIR)/man5/,$(SECTION5))

install-man.always :: $(_install_MANDIR_SECTION5)

$(_install_MANDIR_SECTION5) : $(MANDIR)/man5/% : %
	$(INSTALL.MAN) $< $@

endif

ifneq "$(SECTION6)" ""

_install_directories += $(MANDIR)/man6

_install_MANDIR_SECTION6 := $(addprefix $(MANDIR)/man6/,$(SECTION6))

install-man.always :: $(_install_MANDIR_SECTION6)

$(_install_MANDIR_SECTION6) : $(MANDIR)/man6/% : %
	$(INSTALL.MAN) $< $@

endif

ifneq "$(SECTION7)" ""

_install_directories += $(MANDIR)/man7

_install_MANDIR_SECTION7 := $(addprefix $(MANDIR)/man7/,$(SECTION7))

install-man.always :: $(_install_MANDIR_SECTION7)

$(_install_MANDIR_SECTION7) : $(MANDIR)/man7/% : %
	$(INSTALL.MAN) $< $@

endif

ifneq "$(SECTION8)" ""

_install_directories += $(MANDIR)/man8

_install_MANDIR_SECTION8 := $(addprefix $(MANDIR)/man8/,$(SECTION8))

install-man.always :: $(_install_MANDIR_SECTION8)

$(_install_MANDIR_SECTION8) : $(MANDIR)/man8/% : %
	$(INSTALL.MAN) $< $@

endif

endif

## Installation for auxiliary files (1).

ifneq "$(AUXDIR)" ""
override AUXDIR1 := $(AUXDIR)
override AUXILIARIES1 := $(AUXILIARIES)
endif

ifneq "$(AUXDIR1)" ""

_install_directories += $(AUXDIR1)

ifneq "$(AUXILIARIES1)" ""

_install_AUXDIR1_AUXILIARIES := $(addprefix $(AUXDIR1)/,$(AUXILIARIES1))

install-aux.always :: $(_install_AUXDIR1_AUXILIARIES)

$(_install_AUXDIR1_AUXILIARIES) : $(AUXDIR1)/% : %
	$(INSTALL.AUX) $< $@

endif

endif

## Installation for auxiliary files (2).

ifneq "$(AUXDIR2)" ""

_install_directories += $(AUXDIR2)

ifneq "$(AUXILIARIES2)" ""

_install_AUXDIR2_AUXILIARIES := $(addprefix $(AUXDIR2)/,$(AUXILIARIES2))

install-aux.always :: $(_install_AUXDIR2_AUXILIARIES)

$(_install_AUXDIR2_AUXILIARIES) : $(AUXDIR2)/% : %
	$(INSTALL.AUX) $< $@

endif

endif

## Setup rule for creation of installation directories.

_install_directories := $(sort $(_install_directories) $(INSTALLDIRS))

install.setup :: $(_install_directories)

ifneq "$(_install_directories)" ""
$(_install_directories) : % :
	mkdir $@
endif
