#
# Borland C++ IDE generated makefile
# Modified by David Chatterton September 1994
#       Altered Makefile and added descriptions suitable for 16-bit DOS
#   library for Borland C++ 4.0
#

.AUTODEPEND

#
# OSE_ROOT is where OSE was installed
#

OSE_ROOT = C:\OSE

#
# INCLUDE is where the compiler and OSE include files are
#

INCLUDE = C:\BC4\INCLUDE;$(OSE_ROOT)\INCLUDE

#
# The flags for the compiler are:
# -W-    Make all functions exportable (default)
# -R     Include browser information in object files
# -v     Turn on source debugging
# -vi    Control expansion of inline functions
# -X-    Use compiler autodependancy output
# -f     Allow floating point
# -Hu    Use but don't generate precompiled headers
# -g20   Stop after 20 warning messages
# -j1    Stop after 1 error message
# -w-ccc Turn off warning for condition is always true/false
# -w-rch Turn off warning for unreachable code
#
# There are other warnings you could probablysafely turn off as well
#
# Add -DHAVE_EXCEPTIONS if your C++ compiler supports exceptions.
#

CFLAGS = -W- -R -v -vi -X- -f -Hu -g20 -j1 -w-ccc -w-rch -I$(INCLUDE)

#
# MEM_MODEL indicates the memory model for the library.
# This must be the same as your program you are linking this to.
# -ml    Large Memory Model
#

MEM_MODEL = -ml

#
# LDFLAGS are flags for the linker
# /P32    Set page size to 32
#

LDFLAGS = /P32

#
# CONFIGURE_FILE is the name of the configure file that contains all
# the options for the compiler. These are usually too long to be passed
# to the command line.
#

CONFIGURE_FILE = BccDos.cfg

#
# TARGET is the name of the library
#

TARGET = osel.lib

#
# Borland C++ tools
#

IMPLIB  = Implib
BCCDOS  = Bcc +$(CONFIGURE_FILE)
TLINK   = TLink
TLIB    = TLib $(LDFLAGS)
TASM    = Tasm

#
# Dependency List
#

ose : $(CONFIGURE_FILE) $(TARGET)
  echo MakeNode ose

Dep_osedlib = \
  lib\otc\action.obj \
  lib\otc\alarm.obj \
  lib\otc\align.obj \
  lib\otc\anchor.obj \
  lib\otc\arena.obj \
  lib\otc\asrtfail.obj \
  lib\otc\assert.obj \
  lib\otc\avllnode.obj \
  lib\otc\avlnode.obj \
  lib\otc\avltree.obj \
  lib\otc\bitsetc.obj \
  lib\otc\chunk.obj \
  lib\otc\cluster.obj \
  lib\otc\cmmnpool.obj \
  lib\otc\count.obj \
  lib\otc\cstring.obj \
  lib\otc\date.obj \
  lib\otc\dequei.obj \
  lib\otc\directry.obj \
  lib\otc\dispatch.obj \
  lib\otc\duration.obj \
  lib\otc\ensure.obj \
  lib\otc\errors.obj \
  lib\otc\evagent.obj \
  lib\otc\event.obj \
  lib\otc\eventjob.obj \
  lib\otc\excption.obj \
  lib\otc\globex.obj \
  lib\otc\heap.obj \
  lib\otc\ioevent.obj \
  lib\otc\job.obj \
  lib\otc\jobqueue.obj \
  lib\otc\link.obj \
  lib\otc\linkable.obj \
  lib\otc\linkcurs.obj \
  lib\otc\linkiter.obj \
  lib\otc\linklist.obj \
  lib\otc\listi.obj \
  lib\otc\locality.obj \
  lib\otc\logbuf.obj \
  lib\otc\logger.obj \
  lib\otc\logstrm.obj \
  lib\otc\mcobject.obj \
  lib\otc\mpobject.obj \
  lib\otc\mutex.obj \
  lib\otc\newhndlr.obj \
  lib\otc\nrmutex.obj \
  lib\otc\options.obj \
  lib\otc\outofmem.obj \
  lib\otc\pathname.obj \
  lib\otc\pattern.obj \
  lib\otc\pool.obj \
  lib\otc\precfail.obj \
  lib\otc\program.obj \
  lib\otc\range.obj \
  lib\otc\rcount.obj \
  lib\otc\record.obj \
  lib\otc\regex.obj \
  lib\otc\regexp.obj \
  lib\otc\resource.obj \
  lib\otc\rngecurs.obj \
  lib\otc\rstring.obj \
  lib\otc\stat.obj \
  lib\otc\stophere.obj \
  lib\otc\storage.obj \
  lib\otc\strbuf.obj \
  lib\otc\strgactn.obj \
  lib\otc\string.obj \
  lib\otc\symbol.obj \
  lib\otc\tblentry.obj \
  lib\otc\termfunc.obj \
  lib\otc\termnate.obj \
  lib\otc\time.obj \
  lib\otc\timeout.obj \
  lib\otc\tobject.obj \
  lib\otc\tracepat.obj \
  lib\otc\tracer.obj \
  lib\otc\tracetag.obj \
  lib\otc\trcebuf.obj \
  lib\otc\trcestrm.obj \
  lib\otc\trcswtch.obj \
  lib\otc\typespec.obj \
  lib\otc\warning.obj

clean :
   @echo Deleting Object Files
   -@del lib\otc\*.obj
   @echo Deleting Library Backup
   -@del ose.bak
   @echo Deleting Configure File
   -@del BccDos.cfg

$(TARGET) : $(Dep_osedlib)
  &$(TLIB) $< -+$**

# Stop Make from deleting the library when there is an error
.PRECIOUS: $(TARGET)

.cpp.obj :
  $(BCCDOS) -c -o$@ $<

$(CONFIGURE_FILE) :
  Copy &&|
$(CFLAGS)
$(MEM_MODEL)
| $@
